%define ocamlname tyxml

%global __requires_exclude ^ocaml.Ppx_sigs_reflected.+

Name:           ocaml-%{ocamlname}
Version:        4.2.0
Release:        1%{?dist}.emp1
Summary:        TyXML is a library for building statically correct HTML5 and SVG documents
License:        LGPL with openssl linking exception
URL:            https://ocsigen.org/tyxml/
Source0:        %{ocamlname}-%{version}.tar.gz

Requires:  	ocaml >= 4.02
Requires:	ocaml-camlp4
Requires:	ocaml-uchar
Requires:	ocaml-uutf >= 1.0.0
Requires:	ocaml-re >= 1.5.0
Requires:	ocaml-markup
Requires:	ocaml-ppx_tools_versioned

BuildRequires:  opam-installer >= 2.0
BuildRequires:  ocaml >= 4.02
BuildRequires:  jbuilder
BuildRequires:	ocaml-findlib
BuildRequires:  ocaml-ocamlbuild
BuildRequires:	ocaml-alcotest
BuildRequires:	ocaml-camlp4-devel
BuildRequires:	ocaml-uchar-devel
BuildRequires:	ocaml-uutf-devel >= 1.0.0
BuildRequires:	ocaml-re-devel >= 1.5.0
BuildRequires:	ocaml-markup-devel
BuildRequires:	ocaml-ppx_tools_versioned-devel

%description
TyXML allows you to build HTML5 and SVG trees whose validity is
ensured by the typechecker.  It provides a printer for said XML trees,
along with a ppx syntax extension.  Finally it also provides a
functorial interface to choose your XML datastructure.  It's part of
the ocsigen project and is used in js_of_ocaml and eliom.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:	ocaml-camlp4-devel
Requires:	ocaml-uchar-devel
Requires:	ocaml-uutf-devel >= 1.0.0
Requires:	ocaml-re-devel >= 1.5.0
Requires:	ocaml-markup-devel
Requires:	ocaml-ppx_tools_versioned-devel

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%setup -q -n %{ocamlname}-%{version}
ocaml setup.ml -configure --enable-syntax --enable-ppx \
      --prefix %{_prefix} \
      --libdir %{_libdir} \
      --libexecdir %{_libexecdir} \
      --exec-prefix %{_exec_prefix} \
      --bindir %{_bindir} \
      --sbindir %{_sbindir} \
      --mandir %{_mandir} \
      --datadir %{_datadir} \
      --localstatedir %{_localstatedir} \
      --sharedstatedir %{_sharedstatedir} \
      --destdir $RPM_BUILD_ROOT

%build
ocaml setup.ml -build

%install
export DESTDIR=$RPM_BUILD_ROOT
export OCAMLFIND_DESTDIR=$RPM_BUILD_ROOT%{_libdir}/ocaml
mkdir -p $RPM_BUILD_ROOT%{_libdir}/ocaml
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/ocaml/stublibs
ocaml setup.ml -install 

%check
ocaml setup.ml -configure --enable-syntax --enable-ppx \
      --prefix %{_prefix} \
      --libdir %{_libdir} \
      --libexecdir %{_libexecdir} \
      --exec-prefix %{_exec_prefix} \
      --bindir %{_bindir} \
      --sbindir %{_sbindir} \
      --mandir %{_mandir} \
      --datadir %{_datadir} \
      --localstatedir %{_localstatedir} \
      --sharedstatedir %{_sharedstatedir} \
      --destdir $RPM_BUILD_ROOT \
      --enable-tests

%files
%doc LICENSE
%{_libdir}/ocaml/%{ocamlname}
%{_bindir}/ppx_tyxml_standalone
%ifarch %{ocaml_native_compiler}
%exclude %{_libdir}/ocaml/%{ocamlname}/*.a
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmxa
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%exclude %{_libdir}/ocaml/%{ocamlname}/*.mli

%files devel
%doc README.md CHANGES
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{ocamlname}/*.a
%{_libdir}/ocaml/%{ocamlname}/*.cmxa
%{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%{_libdir}/ocaml/%{ocamlname}/*.mli
